-- ------------------------------------------------------------------------------ --
--                                TradeSkillMaster                                --
--                          https://tradeskillmaster.com                          --
--    All Rights Reserved - Detailed license information included with addon.     --
-- ------------------------------------------------------------------------------ --

local TSM = select(2, ...) ---@type TSM
local FontPaths = TSM.Init("Data.FontPaths") ---@class Data.FontPaths
local private = {
	paths = nil,
}
local ALPHABET_LOOKUP = {
	enUS = "roman",
	esES = "roman",
	esMX = "roman",
	deDE = "roman",
	frFR = "roman",
	itIT = "roman",
	ptBR = "roman",
	koKR = "korean",
	zhCN = "chinese",
	zhTW = "chinese",
	ruRU = "cyrillic",
}



-- ============================================================================
-- Font Path Data
-- ============================================================================

local FONT_PATHS = {
	roman = {
		BodyRegular = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Regular.ttf",
		BodyMedium = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Medium.ttf",
		BodyBold = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Bold.ttf",
		Item = "Fonts\\FRIZQT__.ttf",
		Table = "Interface\\Addons\\TradeSkillMaster\\Media\\Roboto-Medium.ttf",
	},
	korean = {
		BodyRegular = "Fonts\\2002.ttf",
		BodyMedium = "Fonts\\2002.ttf",
		BodyBold = "Fonts\\2002.ttf",
		Item = "Fonts\\2002.ttf",
		Table = "Fonts\\2002.ttf",
	},
	chinese = {
		BodyRegular = "Fonts\\ARKai_C.ttf",
		BodyMedium = "Fonts\\ARKai_C.ttf",
		BodyBold = "Fonts\\ARKai_C.ttf",
		Item = "Fonts\\ARKai_C.ttf",
		Table = "Fonts\\ARKai_C.ttf",
	},
	cyrillic = {
		BodyRegular = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Regular.ttf",
		BodyMedium = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Medium.ttf",
		BodyBold = "Interface\\Addons\\TradeSkillMaster\\Media\\Montserrat-Bold.ttf",
		Item = "Fonts\\FRIZQT___CYR.ttf",
		Table = "Interface\\Addons\\TradeSkillMaster\\Media\\Roboto-Medium.ttf",
	},
}



-- ============================================================================
-- Module Loading
-- ============================================================================

FontPaths:OnModuleLoad(function()
	local alphabet = ALPHABET_LOOKUP[GetLocale()]
	assert(alphabet)
	private.paths = FONT_PATHS[alphabet]
end)



-- ============================================================================
-- Module Functions
-- ============================================================================

function FontPaths.GetBodyRegular()
	return private.paths.BodyRegular
end

function FontPaths.GetBodyMedium()
	return private.paths.BodyMedium
end

function FontPaths.GetBodyBold()
	return private.paths.BodyBold
end

function FontPaths.GetItem()
	return private.paths.Item
end

function FontPaths.GetTable()
	return private.paths.Table
end
